image: node:alpine
stages:
  - test
  - build
  - tag
  - publish

cache:
  key: ${CI_COMMIT_REF_SLUG}
  paths:
    - .npm
    - node_modules

stage_test:
  stage: test
  script:
    - npm ci
    - npm run test:coverage
  except:
    - tags

stage_build:
  stage: build
  script:
    - apk add git
    - git config --global user.email "bot@cyberforce.it"
    - git config --global user.name "Cyberforce CI Bot"
    - npm run set:token
    - npm version patch
    - npm run build
    - cp package.json ./build/package.json
  only:
    - master
  artifacts:
    paths:
      - build
          
stage_tag:
  stage: tag
  script:
    - apk add curl
    - VERSION_NUMBER=$(node -p "require('./build/package.json').version")
    - "curl -H 'Content-Type: application/json' -H \"PRIVATE-TOKEN: $GITLAB_API_TOKEN\" --request POST  \"https://gitlab.com/api/v4/projects/$CI_PROJECT_ID/repository/tags?tag_name=v${VERSION_NUMBER}&ref=$CI_COMMIT_SHA&message=Tagged%20with%20version%20v${VERSION_NUMBER}\""
  only:
    - master
  artifacts:
    paths:
      - build

stage_publish:
  stage: publish
  script:
    - npm run set:token
    - npm run deploy
  only:
    - master
  artifacts:
    paths:
      - build
